// package: localapp
// file: localapp.proto

import * as jspb from "google-protobuf";
import * as supervisor_api_port_pb from "@gitpod/supervisor-api-grpcweb/lib/port_pb";

export class TunnelStatusRequest extends jspb.Message {
  getInstanceId(): string;
  setInstanceId(value: string): void;

  getObserve(): boolean;
  setObserve(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TunnelStatusRequest.AsObject;
  static toObject(includeInstance: boolean, msg: TunnelStatusRequest): TunnelStatusRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TunnelStatusRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TunnelStatusRequest;
  static deserializeBinaryFromReader(message: TunnelStatusRequest, reader: jspb.BinaryReader): TunnelStatusRequest;
}

export namespace TunnelStatusRequest {
  export type AsObject = {
    instanceId: string,
    observe: boolean,
  }
}

export class TunnelStatusResponse extends jspb.Message {
  clearTunnelsList(): void;
  getTunnelsList(): Array<TunnelStatus>;
  setTunnelsList(value: Array<TunnelStatus>): void;
  addTunnels(value?: TunnelStatus, index?: number): TunnelStatus;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TunnelStatusResponse.AsObject;
  static toObject(includeInstance: boolean, msg: TunnelStatusResponse): TunnelStatusResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TunnelStatusResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TunnelStatusResponse;
  static deserializeBinaryFromReader(message: TunnelStatusResponse, reader: jspb.BinaryReader): TunnelStatusResponse;
}

export namespace TunnelStatusResponse {
  export type AsObject = {
    tunnelsList: Array<TunnelStatus.AsObject>,
  }
}

export class TunnelStatus extends jspb.Message {
  getRemotePort(): number;
  setRemotePort(value: number): void;

  getLocalPort(): number;
  setLocalPort(value: number): void;

  getVisibility(): supervisor_api_port_pb.TunnelVisiblityMap[keyof supervisor_api_port_pb.TunnelVisiblityMap];
  setVisibility(value: supervisor_api_port_pb.TunnelVisiblityMap[keyof supervisor_api_port_pb.TunnelVisiblityMap]): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): TunnelStatus.AsObject;
  static toObject(includeInstance: boolean, msg: TunnelStatus): TunnelStatus.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: TunnelStatus, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): TunnelStatus;
  static deserializeBinaryFromReader(message: TunnelStatus, reader: jspb.BinaryReader): TunnelStatus;
}

export namespace TunnelStatus {
  export type AsObject = {
    remotePort: number,
    localPort: number,
    visibility: supervisor_api_port_pb.TunnelVisiblityMap[keyof supervisor_api_port_pb.TunnelVisiblityMap],
  }
}

export class AutoTunnelRequest extends jspb.Message {
  getInstanceId(): string;
  setInstanceId(value: string): void;

  getEnabled(): boolean;
  setEnabled(value: boolean): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AutoTunnelRequest.AsObject;
  static toObject(includeInstance: boolean, msg: AutoTunnelRequest): AutoTunnelRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AutoTunnelRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AutoTunnelRequest;
  static deserializeBinaryFromReader(message: AutoTunnelRequest, reader: jspb.BinaryReader): AutoTunnelRequest;
}

export namespace AutoTunnelRequest {
  export type AsObject = {
    instanceId: string,
    enabled: boolean,
  }
}

export class AutoTunnelResponse extends jspb.Message {
  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): AutoTunnelResponse.AsObject;
  static toObject(includeInstance: boolean, msg: AutoTunnelResponse): AutoTunnelResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: AutoTunnelResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): AutoTunnelResponse;
  static deserializeBinaryFromReader(message: AutoTunnelResponse, reader: jspb.BinaryReader): AutoTunnelResponse;
}

export namespace AutoTunnelResponse {
  export type AsObject = {
  }
}

export class ResolveSSHConnectionRequest extends jspb.Message {
  getInstanceId(): string;
  setInstanceId(value: string): void;

  getWorkspaceId(): string;
  setWorkspaceId(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ResolveSSHConnectionRequest.AsObject;
  static toObject(includeInstance: boolean, msg: ResolveSSHConnectionRequest): ResolveSSHConnectionRequest.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ResolveSSHConnectionRequest, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ResolveSSHConnectionRequest;
  static deserializeBinaryFromReader(message: ResolveSSHConnectionRequest, reader: jspb.BinaryReader): ResolveSSHConnectionRequest;
}

export namespace ResolveSSHConnectionRequest {
  export type AsObject = {
    instanceId: string,
    workspaceId: string,
  }
}

export class ResolveSSHConnectionResponse extends jspb.Message {
  getConfigFile(): string;
  setConfigFile(value: string): void;

  getHost(): string;
  setHost(value: string): void;

  serializeBinary(): Uint8Array;
  toObject(includeInstance?: boolean): ResolveSSHConnectionResponse.AsObject;
  static toObject(includeInstance: boolean, msg: ResolveSSHConnectionResponse): ResolveSSHConnectionResponse.AsObject;
  static extensions: {[key: number]: jspb.ExtensionFieldInfo<jspb.Message>};
  static extensionsBinary: {[key: number]: jspb.ExtensionFieldBinaryInfo<jspb.Message>};
  static serializeBinaryToWriter(message: ResolveSSHConnectionResponse, writer: jspb.BinaryWriter): void;
  static deserializeBinary(bytes: Uint8Array): ResolveSSHConnectionResponse;
  static deserializeBinaryFromReader(message: ResolveSSHConnectionResponse, reader: jspb.BinaryReader): ResolveSSHConnectionResponse;
}

export namespace ResolveSSHConnectionResponse {
  export type AsObject = {
    configFile: string,
    host: string,
  }
}

